#define TAKTFREQUENZ 8000000
#define BAUDRATE 38400
//#define WLANBAUDRATE 38400
#define WLANBAUDRATE 9600
//#define WLANBAUDRATE 115200
#define PUFFERGROESSE 100

class SERIAL
{
public:
    bool OK;
    bool ERR;

    char NEUSTESZEICHEN;
    char VORZEICHEN;
    char VORVORZEICHEN;
    char nzeichen;

    char puffer[PUFFERGROESSE];

    int index_schreiben;
    int index_lesen;
    int index;
    char vorzeichen;

    unsigned int baudregister;

    SERIAL()
    {
        baudregister = TAKTFREQUENZ/8/BAUDRATE-1;

        index_schreiben = 0;
        index_lesen     = 0;

        vorzeichen     = ' ';

        NEUSTESZEICHEN = ' ';
        VORZEICHEN     = ' ';
        VORVORZEICHEN  = ' ';

        OK = false;

        //Seriell konfigurieren:
        //Aktivieren der RS232-Schnittstelle des Mikrocontrollers:
    
        //setzen der Baudrate
        UBRRH = (unsigned char) (baudregister>>8); //Setzen des HIGH-Bytes des Baudraten-Registers
        UBRRL = (unsigned char)  baudregister;     //Setzen des LOW -Bytes des Baudraten-Registers
	
        //Einschalten des Senders und des Empfängers
        UCSRB = (1<<TXEN) | (1<<RXEN);
		        
        //Setzen des Nachrichtenformats: 8 Datenbits, 1 Stopbits
        UCSRC = (1<<URSEL)|(1<<UCSZ0)|(1<<UCSZ1);
        UCSRA = (1<<U2X);
    }

    void initWLAN()
    {
        //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        baudregister = TAKTFREQUENZ/8/WLANBAUDRATE-1;
        //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        index_schreiben = 0;
        index_lesen     = 0;

        vorzeichen = ' ';

        //Seriell konfigurieren:
        //Aktivieren der RS232-Schnittstelle des Mikrocontrollers:
    
        //setzen der Baudrate
        UBRRH = (unsigned char) (baudregister>>8); //Setzen des HIGH-Bytes des Baudraten-Registers
        UBRRL = (unsigned char)  baudregister;     //Setzen des LOW -Bytes des Baudraten-Registers
	
        //Einschalten des Senders und des Empfängers
        UCSRB = (1<<TXEN) | (1<<RXEN);
		        
        //Setzen des Nachrichtenformats: 8 Datenbits, 1 Stopbits
        UCSRC = (1<<URSEL)|(1<<UCSZ0)|(1<<UCSZ1);
        UCSRA = (1<<U2X);
    }

    bool sendeZeichen(uint8_t zeichen)
    {
        if( (UCSRA & (1<<UDRE)) ) //Schauen, ob der Uebertragungspuffer leer ist
        {
            UDR = zeichen;                    //Daten in den Puffer schreiben und übertragen
            return true;
        }
        else
        {
            return false;
        }
    }

    void aktualisieren()
    {

        //Empfangen hat Vorang vor schreiben:
        if(  (UCSRA & (1<<RXC)) ) //Wenn Zeichen empfangen wurde
        {
            nzeichen = UDR;
            if(   (nzeichen>='0' && nzeichen<='9')  || (nzeichen>='A' && nzeichen<='Z') )            
            {
               VORVORZEICHEN  = VORZEICHEN;
               VORZEICHEN     = NEUSTESZEICHEN;
               NEUSTESZEICHEN = nzeichen;

               if(VORZEICHEN=='O' && NEUSTESZEICHEN=='K')
               {
                   OK = true;
               }
               if(VORVORZEICHEN=='E' && VORZEICHEN=='R' && NEUSTESZEICHEN=='R')
               {
                   ERR = true;
               }
            }
        }
        else if( (UCSRA & (1<<UDRE)) && index_lesen!=index_schreiben)
        {
            UDR = puffer[index_lesen]; //Daten in den Puffer schreiben und übertragen
            index_lesen++;
            index_lesen%=PUFFERGROESSE;
        }
    }
    
    void sendeZeichenGepuffert(char c)
    {
        puffer[index_schreiben] = c;
        index_schreiben++;
        index_schreiben%=PUFFERGROESSE;
    }

    void sendeText(const char* text)
    {
         index=0;
         while(text[index]!='\0')
         {
             puffer[index_schreiben]=text[index];
             index++;
             index_schreiben++;
             index_schreiben%=PUFFERGROESSE;
         }
    }

    void sendeZahl(int zahl)
    {
        if(zahl<0)
        {
            vorzeichen = '-';
            zahl = -zahl;
        }
        else
        {
            vorzeichen = ' ';
        }

        puffer[(index_schreiben+4)%PUFFERGROESSE] = 48+zahl%10;
        zahl/=10;
        puffer[(index_schreiben+3)%PUFFERGROESSE] = 48+zahl%10;
        zahl/=10;
        puffer[(index_schreiben+2)%PUFFERGROESSE] = 48+zahl%10;
        zahl/=10;
        puffer[(index_schreiben+1)%PUFFERGROESSE] = 48+zahl%10;
        puffer[(index_schreiben+0)%PUFFERGROESSE] = ' ';
        index_schreiben+=5;
        index_schreiben%=PUFFERGROESSE;
    }

    //Gibt das zuletzt empfangene gültige Zeichen zurück.
    char holeZeichen()
    {
        return NEUSTESZEICHEN;
    }
    char holeVorZeichen()
    {
        return VORZEICHEN;
    }
    char holeVorVorZeichen()
    {
        return VORVORZEICHEN;
    }

    void setOKfalse()
    {
        OK = false;
    }
    void setERRfalse()
    {
        ERR = false;
    }

    bool getOK()
    {
        return OK;
    }
    bool getERR()
    {
        return ERR;
    }

} serial;
